# PatchJob

List all patch job endpoint

## GET /v3/patchJob/type

> Get list of patch job types

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"PatchJob","description":"List all patch job endpoint"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"PatchJobType":{"type":"object","required":["typeId","typeDescription"],"properties":{"typeId":{"type":"integer","format":"integer","description":"Patch job type ID","readOnly":true},"typeDescription":{"type":"string","format":"","description":"Patch job type description","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/patchJob/type":{"get":{"tags":["PatchJob"],"summary":"Get list of patch job types","operationId":"getPatchJobTypes","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobType"}}}}},"403":{"description":"Invalid credentials"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/patchJob/runtimeType

> Get list of patch job runtime types

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"PatchJob","description":"List all patch job endpoint"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"PatchJobRuntimeType":{"type":"object","required":["typeId","typeDescription"],"properties":{"typeId":{"type":"integer","format":"integer","description":"Patch job type ID","readOnly":true},"typeDescription":{"type":"string","format":"","description":"Patch job type description","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/patchJob/runtimeType":{"get":{"tags":["PatchJob"],"summary":"Get list of patch job runtime types","operationId":"getPatchJobRuntimeTypes","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobRuntimeType"}}}}},"403":{"description":"Invalid credentials"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/patchJob/status

> Get list of patch job status

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"PatchJob","description":"List all patch job endpoint"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"PatchJobStatus":{"type":"object","required":["id","description"],"properties":{"id":{"type":"integer","format":"integer","description":"Patch job status ID","readOnly":true},"description":{"type":"string","format":"","description":"Patch job status description","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/patchJob/status":{"get":{"tags":["PatchJob"],"summary":"Get list of patch job status","operationId":"getPatchJobStatuses","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobStatus"}}}}},"403":{"description":"Invalid credentials"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## POST /v3/patchJob/applicationInstancePreview

> Show a preview of the number of game application instances that are affected by the selection

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"PatchJob","description":"List all patch job endpoint"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"PatchJobApplicationInstancePreview":{"type":"object","required":["deploymentEnvironmentId","applicationId","fleet","applicationBuild"],"properties":{"deploymentEnvironmentId":{"type":"string","format":"","description":"Deployment environment ID"},"applicationId":{"type":"string","format":"","description":"Application ID"},"fleet":{"type":"array","items":{"type":"string","format":""},"description":"List of fleet ID"},"applicationBuild":{"type":"array","items":{"type":"string","format":""},"description":"List of application build ID"}},"additionalProperties":false},"PatchJobApplicationInstanceCount":{"type":"object","required":["region","dataCenter","buildVersion","numberOfInstances"],"properties":{"region":{"type":"string","format":"","description":"Region name of application instances","readOnly":true},"dataCenter":{"type":"string","format":"","description":"Data center location name","readOnly":true},"buildVersion":{"type":"string","format":"","description":"Application build version number","readOnly":true},"numberOfInstances":{"type":"integer","format":"integer","description":"Number of application instances","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/patchJob/applicationInstancePreview":{"post":{"tags":["PatchJob"],"summary":"Show a preview of the number of game application instances that are affected by the selection","operationId":"createPatchJobApplicationInstancePreview","requestBody":{"description":"","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PatchJobApplicationInstancePreview"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobApplicationInstanceCount"}}}}},"403":{"description":"Invalid credentials"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/patchJob

> Get the list of all patch jobs

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"PatchJob","description":"List all patch job endpoint"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"PatchJob":{"type":"object","required":["id","deploymentEnvironmentId","applicationId","patchJobMethodId","patchJobMethod","patchJobName","status","stopMethodId","stopMethodName","patchJobStartTime","patchJobOverallProgress","applicationBuild","fleet","createdAt","changedAt","finishedAt","isRevertable","revertsPatchJobId","revertedByPatchJobId"],"properties":{"id":{"type":"string","format":"","description":"Patch job ID","readOnly":true},"deploymentEnvironmentId":{"type":"string","format":"","description":"Deployment environment ID"},"applicationId":{"type":"string","format":"","description":"Application ID"},"patchJobMethodId":{"type":"integer","format":"integer","description":"Patch job type, you can find the list available patch job type [`GET /v3/patchJob/type`](game-publisher#/PatchJob/get_v3_patchJob_type)"},"patchJobMethod":{"type":"string","format":"","description":"Name of the patch job method","readOnly":true},"patchJobName":{"type":"string","format":"","description":"Name of the patch job (unique)"},"status":{"type":"integer","format":"integer","description":"Status of the patch job, you can find the list available patch job type [`GET /v3/patchJob/status`](game-publisher#/PatchJob/get_v3_patchJob_status)","readOnly":true},"stopMethodId":{"type":"integer","format":"integer","description":"Stop method of an application instance, you can find the list available application instance stop methods [`GET /v3/application/stopMethod`](game-publisher#/Application/get_v3_application_stopMethod)"},"stopMethodName":{"type":"string","format":"","description":"Name of the stop method","readOnly":true},"stopMethodTimeout":{"type":"integer","format":"integer","description":"Stop method timeout of an application instance in seconds"},"comments":{"type":"string","format":"","description":"Comments for patch job"},"schedulerStartTime":{"type":"integer","format":"integer","description":"Start time when the patch job will be started. The default value is 0, this means start directly after creation of the patch job, else the patch job will start at the provided UTC timestamp"},"patchJobStartTime":{"type":"integer","format":"integer","description":"Timestamp when the patch job has been started in UTC","readOnly":true},"patchJobOverallProgress":{"allOf":[{"$ref":"#/components/schemas/PatchJobReportProgress"}],"description":"How many application instances are being patched","nullable":true,"readOnly":true},"applicationBuild":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobApplicationBuild"},"description":"Array of old and new application build needs to be patched"},"fleet":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobFleet"},"description":"Array of fleet that needs to be patched"},"email":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobEmail"},"description":"Array of email address for reporting purposes"},"createdAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job has been created","readOnly":true},"changedAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job last has been changed","readOnly":true},"finishedAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job has been finished in UTC","readOnly":true},"isRevertable":{"type":"integer","format":"integer","description":"If the patch job can be cancelled, when is 1 you can cancel the patch job else not","readOnly":true},"revertsPatchJobId":{"type":"integer","format":"integer","description":"If filled in, this ID points to the patch job that has been reverted by this patch job","nullable":true,"readOnly":true},"revertedByPatchJobId":{"type":"integer","format":"integer","description":"If filled in, this ID points to the PatchJob that has reverted this patch job","nullable":true,"readOnly":true}},"additionalProperties":false},"PatchJobReportProgress":{"type":"object","required":["total","downloaded","stopped","success","failed","started","canceled","remaining"],"properties":{"total":{"type":"integer","format":"integer","description":"The total amount of application instances affected by the patch job","readOnly":true},"downloaded":{"type":"integer","format":"integer","description":"The amount of downloaded application instances","readOnly":true},"stopped":{"type":"integer","format":"integer","description":"The amount of stopped application instances","readOnly":true},"success":{"type":"integer","format":"integer","description":"The amount of successfully patched application instances","readOnly":true},"failed":{"type":"integer","format":"integer","description":"The amount of failed application instances","readOnly":true},"started":{"type":"integer","format":"integer","description":"The amount of started application instances","readOnly":true},"canceled":{"type":"integer","format":"integer","description":"The amount of canceled application instances","readOnly":true},"remaining":{"type":"integer","format":"integer","description":"The amount of remaining application instances","readOnly":true}},"additionalProperties":false,"nullable":true},"PatchJobApplicationBuild":{"type":"object","required":["id","oldApplicationBuildId","newApplicationBuildId"],"properties":{"id":{"type":"string","format":"","description":"ID of a patch job application build","readOnly":true},"oldApplicationBuildId":{"type":"string","format":"","description":"ID of an old application build"},"newApplicationBuildId":{"type":"string","format":"","description":"ID of a new application build"}},"additionalProperties":false},"PatchJobFleet":{"type":"object","required":["id","fleetId"],"properties":{"id":{"type":"string","format":"","description":"ID of a patch job fleet","readOnly":true},"fleetId":{"type":"string","format":"","description":"ID of fleet"}},"additionalProperties":false},"PatchJobEmail":{"type":"object","required":["id","email","progressReport","resultReport","createdAt","changedAt"],"properties":{"id":{"type":"string","format":"","description":"ID of a patch job email","readOnly":true},"email":{"type":"string","format":"","description":"Email address for reporting (unique)"},"progressReport":{"type":"integer","format":"integer","description":"If 1 progress report will be send, if 0 no progress report will be send"},"resultReport":{"type":"integer","format":"integer","description":"If 1 result report will be send, if 0 no result report will be send"},"createdAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job email has been created","readOnly":true},"changedAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job email last has been changed","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/patchJob":{"get":{"tags":["PatchJob"],"summary":"Get the list of all patch jobs","operationId":"getPatchJobs","parameters":[{"name":"RANGED-DATA","in":"header","description":"Example header and default range: RANGED-DATA:start=0,results=25","schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/PatchJob"}}}}},"403":{"description":"Invalid credentials"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## POST /v3/patchJob

> Create a patch job

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"PatchJob","description":"List all patch job endpoint"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"PatchJob":{"type":"object","required":["id","deploymentEnvironmentId","applicationId","patchJobMethodId","patchJobMethod","patchJobName","status","stopMethodId","stopMethodName","patchJobStartTime","patchJobOverallProgress","applicationBuild","fleet","createdAt","changedAt","finishedAt","isRevertable","revertsPatchJobId","revertedByPatchJobId"],"properties":{"id":{"type":"string","format":"","description":"Patch job ID","readOnly":true},"deploymentEnvironmentId":{"type":"string","format":"","description":"Deployment environment ID"},"applicationId":{"type":"string","format":"","description":"Application ID"},"patchJobMethodId":{"type":"integer","format":"integer","description":"Patch job type, you can find the list available patch job type [`GET /v3/patchJob/type`](game-publisher#/PatchJob/get_v3_patchJob_type)"},"patchJobMethod":{"type":"string","format":"","description":"Name of the patch job method","readOnly":true},"patchJobName":{"type":"string","format":"","description":"Name of the patch job (unique)"},"status":{"type":"integer","format":"integer","description":"Status of the patch job, you can find the list available patch job type [`GET /v3/patchJob/status`](game-publisher#/PatchJob/get_v3_patchJob_status)","readOnly":true},"stopMethodId":{"type":"integer","format":"integer","description":"Stop method of an application instance, you can find the list available application instance stop methods [`GET /v3/application/stopMethod`](game-publisher#/Application/get_v3_application_stopMethod)"},"stopMethodName":{"type":"string","format":"","description":"Name of the stop method","readOnly":true},"stopMethodTimeout":{"type":"integer","format":"integer","description":"Stop method timeout of an application instance in seconds"},"comments":{"type":"string","format":"","description":"Comments for patch job"},"schedulerStartTime":{"type":"integer","format":"integer","description":"Start time when the patch job will be started. The default value is 0, this means start directly after creation of the patch job, else the patch job will start at the provided UTC timestamp"},"patchJobStartTime":{"type":"integer","format":"integer","description":"Timestamp when the patch job has been started in UTC","readOnly":true},"patchJobOverallProgress":{"allOf":[{"$ref":"#/components/schemas/PatchJobReportProgress"}],"description":"How many application instances are being patched","nullable":true,"readOnly":true},"applicationBuild":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobApplicationBuild"},"description":"Array of old and new application build needs to be patched"},"fleet":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobFleet"},"description":"Array of fleet that needs to be patched"},"email":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobEmail"},"description":"Array of email address for reporting purposes"},"createdAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job has been created","readOnly":true},"changedAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job last has been changed","readOnly":true},"finishedAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job has been finished in UTC","readOnly":true},"isRevertable":{"type":"integer","format":"integer","description":"If the patch job can be cancelled, when is 1 you can cancel the patch job else not","readOnly":true},"revertsPatchJobId":{"type":"integer","format":"integer","description":"If filled in, this ID points to the patch job that has been reverted by this patch job","nullable":true,"readOnly":true},"revertedByPatchJobId":{"type":"integer","format":"integer","description":"If filled in, this ID points to the PatchJob that has reverted this patch job","nullable":true,"readOnly":true}},"additionalProperties":false},"PatchJobReportProgress":{"type":"object","required":["total","downloaded","stopped","success","failed","started","canceled","remaining"],"properties":{"total":{"type":"integer","format":"integer","description":"The total amount of application instances affected by the patch job","readOnly":true},"downloaded":{"type":"integer","format":"integer","description":"The amount of downloaded application instances","readOnly":true},"stopped":{"type":"integer","format":"integer","description":"The amount of stopped application instances","readOnly":true},"success":{"type":"integer","format":"integer","description":"The amount of successfully patched application instances","readOnly":true},"failed":{"type":"integer","format":"integer","description":"The amount of failed application instances","readOnly":true},"started":{"type":"integer","format":"integer","description":"The amount of started application instances","readOnly":true},"canceled":{"type":"integer","format":"integer","description":"The amount of canceled application instances","readOnly":true},"remaining":{"type":"integer","format":"integer","description":"The amount of remaining application instances","readOnly":true}},"additionalProperties":false,"nullable":true},"PatchJobApplicationBuild":{"type":"object","required":["id","oldApplicationBuildId","newApplicationBuildId"],"properties":{"id":{"type":"string","format":"","description":"ID of a patch job application build","readOnly":true},"oldApplicationBuildId":{"type":"string","format":"","description":"ID of an old application build"},"newApplicationBuildId":{"type":"string","format":"","description":"ID of a new application build"}},"additionalProperties":false},"PatchJobFleet":{"type":"object","required":["id","fleetId"],"properties":{"id":{"type":"string","format":"","description":"ID of a patch job fleet","readOnly":true},"fleetId":{"type":"string","format":"","description":"ID of fleet"}},"additionalProperties":false},"PatchJobEmail":{"type":"object","required":["id","email","progressReport","resultReport","createdAt","changedAt"],"properties":{"id":{"type":"string","format":"","description":"ID of a patch job email","readOnly":true},"email":{"type":"string","format":"","description":"Email address for reporting (unique)"},"progressReport":{"type":"integer","format":"integer","description":"If 1 progress report will be send, if 0 no progress report will be send"},"resultReport":{"type":"integer","format":"integer","description":"If 1 result report will be send, if 0 no result report will be send"},"createdAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job email has been created","readOnly":true},"changedAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job email last has been changed","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/patchJob":{"post":{"tags":["PatchJob"],"summary":"Create a patch job","operationId":"createPatchJob","requestBody":{"description":"","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PatchJob"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/PatchJob"}}}}},"403":{"description":"Invalid credentials"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/patchJob/{patchJobId}

> Get the detail of a patch job

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"PatchJob","description":"List all patch job endpoint"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"PatchJob":{"type":"object","required":["id","deploymentEnvironmentId","applicationId","patchJobMethodId","patchJobMethod","patchJobName","status","stopMethodId","stopMethodName","patchJobStartTime","patchJobOverallProgress","applicationBuild","fleet","createdAt","changedAt","finishedAt","isRevertable","revertsPatchJobId","revertedByPatchJobId"],"properties":{"id":{"type":"string","format":"","description":"Patch job ID","readOnly":true},"deploymentEnvironmentId":{"type":"string","format":"","description":"Deployment environment ID"},"applicationId":{"type":"string","format":"","description":"Application ID"},"patchJobMethodId":{"type":"integer","format":"integer","description":"Patch job type, you can find the list available patch job type [`GET /v3/patchJob/type`](game-publisher#/PatchJob/get_v3_patchJob_type)"},"patchJobMethod":{"type":"string","format":"","description":"Name of the patch job method","readOnly":true},"patchJobName":{"type":"string","format":"","description":"Name of the patch job (unique)"},"status":{"type":"integer","format":"integer","description":"Status of the patch job, you can find the list available patch job type [`GET /v3/patchJob/status`](game-publisher#/PatchJob/get_v3_patchJob_status)","readOnly":true},"stopMethodId":{"type":"integer","format":"integer","description":"Stop method of an application instance, you can find the list available application instance stop methods [`GET /v3/application/stopMethod`](game-publisher#/Application/get_v3_application_stopMethod)"},"stopMethodName":{"type":"string","format":"","description":"Name of the stop method","readOnly":true},"stopMethodTimeout":{"type":"integer","format":"integer","description":"Stop method timeout of an application instance in seconds"},"comments":{"type":"string","format":"","description":"Comments for patch job"},"schedulerStartTime":{"type":"integer","format":"integer","description":"Start time when the patch job will be started. The default value is 0, this means start directly after creation of the patch job, else the patch job will start at the provided UTC timestamp"},"patchJobStartTime":{"type":"integer","format":"integer","description":"Timestamp when the patch job has been started in UTC","readOnly":true},"patchJobOverallProgress":{"allOf":[{"$ref":"#/components/schemas/PatchJobReportProgress"}],"description":"How many application instances are being patched","nullable":true,"readOnly":true},"applicationBuild":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobApplicationBuild"},"description":"Array of old and new application build needs to be patched"},"fleet":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobFleet"},"description":"Array of fleet that needs to be patched"},"email":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobEmail"},"description":"Array of email address for reporting purposes"},"createdAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job has been created","readOnly":true},"changedAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job last has been changed","readOnly":true},"finishedAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job has been finished in UTC","readOnly":true},"isRevertable":{"type":"integer","format":"integer","description":"If the patch job can be cancelled, when is 1 you can cancel the patch job else not","readOnly":true},"revertsPatchJobId":{"type":"integer","format":"integer","description":"If filled in, this ID points to the patch job that has been reverted by this patch job","nullable":true,"readOnly":true},"revertedByPatchJobId":{"type":"integer","format":"integer","description":"If filled in, this ID points to the PatchJob that has reverted this patch job","nullable":true,"readOnly":true}},"additionalProperties":false},"PatchJobReportProgress":{"type":"object","required":["total","downloaded","stopped","success","failed","started","canceled","remaining"],"properties":{"total":{"type":"integer","format":"integer","description":"The total amount of application instances affected by the patch job","readOnly":true},"downloaded":{"type":"integer","format":"integer","description":"The amount of downloaded application instances","readOnly":true},"stopped":{"type":"integer","format":"integer","description":"The amount of stopped application instances","readOnly":true},"success":{"type":"integer","format":"integer","description":"The amount of successfully patched application instances","readOnly":true},"failed":{"type":"integer","format":"integer","description":"The amount of failed application instances","readOnly":true},"started":{"type":"integer","format":"integer","description":"The amount of started application instances","readOnly":true},"canceled":{"type":"integer","format":"integer","description":"The amount of canceled application instances","readOnly":true},"remaining":{"type":"integer","format":"integer","description":"The amount of remaining application instances","readOnly":true}},"additionalProperties":false,"nullable":true},"PatchJobApplicationBuild":{"type":"object","required":["id","oldApplicationBuildId","newApplicationBuildId"],"properties":{"id":{"type":"string","format":"","description":"ID of a patch job application build","readOnly":true},"oldApplicationBuildId":{"type":"string","format":"","description":"ID of an old application build"},"newApplicationBuildId":{"type":"string","format":"","description":"ID of a new application build"}},"additionalProperties":false},"PatchJobFleet":{"type":"object","required":["id","fleetId"],"properties":{"id":{"type":"string","format":"","description":"ID of a patch job fleet","readOnly":true},"fleetId":{"type":"string","format":"","description":"ID of fleet"}},"additionalProperties":false},"PatchJobEmail":{"type":"object","required":["id","email","progressReport","resultReport","createdAt","changedAt"],"properties":{"id":{"type":"string","format":"","description":"ID of a patch job email","readOnly":true},"email":{"type":"string","format":"","description":"Email address for reporting (unique)"},"progressReport":{"type":"integer","format":"integer","description":"If 1 progress report will be send, if 0 no progress report will be send"},"resultReport":{"type":"integer","format":"integer","description":"If 1 result report will be send, if 0 no result report will be send"},"createdAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job email has been created","readOnly":true},"changedAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job email last has been changed","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/patchJob/{patchJobId}":{"get":{"tags":["PatchJob"],"summary":"Get the detail of a patch job","operationId":"getPatchJob","parameters":[{"name":"patchJobId","in":"path","description":"The Id of the patch job for which to fetch the information","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/PatchJob"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid patchJobId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## PUT /v3/patchJob/{patchJobId}

> Update the detail of a patch job

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"PatchJob","description":"List all patch job endpoint"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"PatchJob":{"type":"object","required":["id","deploymentEnvironmentId","applicationId","patchJobMethodId","patchJobMethod","patchJobName","status","stopMethodId","stopMethodName","patchJobStartTime","patchJobOverallProgress","applicationBuild","fleet","createdAt","changedAt","finishedAt","isRevertable","revertsPatchJobId","revertedByPatchJobId"],"properties":{"id":{"type":"string","format":"","description":"Patch job ID","readOnly":true},"deploymentEnvironmentId":{"type":"string","format":"","description":"Deployment environment ID"},"applicationId":{"type":"string","format":"","description":"Application ID"},"patchJobMethodId":{"type":"integer","format":"integer","description":"Patch job type, you can find the list available patch job type [`GET /v3/patchJob/type`](game-publisher#/PatchJob/get_v3_patchJob_type)"},"patchJobMethod":{"type":"string","format":"","description":"Name of the patch job method","readOnly":true},"patchJobName":{"type":"string","format":"","description":"Name of the patch job (unique)"},"status":{"type":"integer","format":"integer","description":"Status of the patch job, you can find the list available patch job type [`GET /v3/patchJob/status`](game-publisher#/PatchJob/get_v3_patchJob_status)","readOnly":true},"stopMethodId":{"type":"integer","format":"integer","description":"Stop method of an application instance, you can find the list available application instance stop methods [`GET /v3/application/stopMethod`](game-publisher#/Application/get_v3_application_stopMethod)"},"stopMethodName":{"type":"string","format":"","description":"Name of the stop method","readOnly":true},"stopMethodTimeout":{"type":"integer","format":"integer","description":"Stop method timeout of an application instance in seconds"},"comments":{"type":"string","format":"","description":"Comments for patch job"},"schedulerStartTime":{"type":"integer","format":"integer","description":"Start time when the patch job will be started. The default value is 0, this means start directly after creation of the patch job, else the patch job will start at the provided UTC timestamp"},"patchJobStartTime":{"type":"integer","format":"integer","description":"Timestamp when the patch job has been started in UTC","readOnly":true},"patchJobOverallProgress":{"allOf":[{"$ref":"#/components/schemas/PatchJobReportProgress"}],"description":"How many application instances are being patched","nullable":true,"readOnly":true},"applicationBuild":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobApplicationBuild"},"description":"Array of old and new application build needs to be patched"},"fleet":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobFleet"},"description":"Array of fleet that needs to be patched"},"email":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobEmail"},"description":"Array of email address for reporting purposes"},"createdAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job has been created","readOnly":true},"changedAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job last has been changed","readOnly":true},"finishedAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job has been finished in UTC","readOnly":true},"isRevertable":{"type":"integer","format":"integer","description":"If the patch job can be cancelled, when is 1 you can cancel the patch job else not","readOnly":true},"revertsPatchJobId":{"type":"integer","format":"integer","description":"If filled in, this ID points to the patch job that has been reverted by this patch job","nullable":true,"readOnly":true},"revertedByPatchJobId":{"type":"integer","format":"integer","description":"If filled in, this ID points to the PatchJob that has reverted this patch job","nullable":true,"readOnly":true}},"additionalProperties":false},"PatchJobReportProgress":{"type":"object","required":["total","downloaded","stopped","success","failed","started","canceled","remaining"],"properties":{"total":{"type":"integer","format":"integer","description":"The total amount of application instances affected by the patch job","readOnly":true},"downloaded":{"type":"integer","format":"integer","description":"The amount of downloaded application instances","readOnly":true},"stopped":{"type":"integer","format":"integer","description":"The amount of stopped application instances","readOnly":true},"success":{"type":"integer","format":"integer","description":"The amount of successfully patched application instances","readOnly":true},"failed":{"type":"integer","format":"integer","description":"The amount of failed application instances","readOnly":true},"started":{"type":"integer","format":"integer","description":"The amount of started application instances","readOnly":true},"canceled":{"type":"integer","format":"integer","description":"The amount of canceled application instances","readOnly":true},"remaining":{"type":"integer","format":"integer","description":"The amount of remaining application instances","readOnly":true}},"additionalProperties":false,"nullable":true},"PatchJobApplicationBuild":{"type":"object","required":["id","oldApplicationBuildId","newApplicationBuildId"],"properties":{"id":{"type":"string","format":"","description":"ID of a patch job application build","readOnly":true},"oldApplicationBuildId":{"type":"string","format":"","description":"ID of an old application build"},"newApplicationBuildId":{"type":"string","format":"","description":"ID of a new application build"}},"additionalProperties":false},"PatchJobFleet":{"type":"object","required":["id","fleetId"],"properties":{"id":{"type":"string","format":"","description":"ID of a patch job fleet","readOnly":true},"fleetId":{"type":"string","format":"","description":"ID of fleet"}},"additionalProperties":false},"PatchJobEmail":{"type":"object","required":["id","email","progressReport","resultReport","createdAt","changedAt"],"properties":{"id":{"type":"string","format":"","description":"ID of a patch job email","readOnly":true},"email":{"type":"string","format":"","description":"Email address for reporting (unique)"},"progressReport":{"type":"integer","format":"integer","description":"If 1 progress report will be send, if 0 no progress report will be send"},"resultReport":{"type":"integer","format":"integer","description":"If 1 result report will be send, if 0 no result report will be send"},"createdAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job email has been created","readOnly":true},"changedAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job email last has been changed","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/patchJob/{patchJobId}":{"put":{"tags":["PatchJob"],"summary":"Update the detail of a patch job","operationId":"updatePatchJob","parameters":[{"name":"patchJobId","in":"path","description":"The Id of the patch job","required":true,"schema":{"type":"string"}}],"requestBody":{"description":"","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PatchJob"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/PatchJob"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid patchJobId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/patchJob/summary

> Get summary of all patch jobs

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"PatchJob","description":"List all patch job endpoint"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"PatchJobSummary":{"type":"object","required":["id","deploymentEnvironmentId","applicationId","applicationName","newApplicationBuildName","patchJobMethodId","patchJobMethodName","patchJobName","status","comments","schedulerStartTime","patchJobStartTime","finishedAt","isRevertable","patchJobOverallProgress"],"properties":{"id":{"type":"string","format":"","description":"Patch job ID","readOnly":true},"deploymentEnvironmentId":{"type":"string","format":"","description":"Deployment environment ID","readOnly":true},"applicationId":{"type":"string","format":"","description":"Application ID","readOnly":true},"applicationName":{"type":"string","format":"","description":"Name of the application","readOnly":true},"newApplicationBuildName":{"type":"string","format":"","description":"Name of all the application builds that will be patched","readOnly":true},"patchJobMethodId":{"type":"integer","format":"integer","description":"Patch job type, you can find the list available patch job type [`GET /v3/patchJob/type`](game-publisher#/PatchJob/get_v3_patchJob_type)","readOnly":true},"patchJobMethodName":{"type":"string","format":"","description":"Name of the patch job chosen","readOnly":true},"patchJobName":{"type":"string","format":"","description":"Name of the patch job (unique)","readOnly":true},"status":{"type":"integer","format":"integer","description":"Status of the patch job","readOnly":true},"comments":{"type":"string","format":"","description":"Comments for patch job","readOnly":true},"schedulerStartTime":{"type":"integer","format":"integer","description":"When the patch job needs to start, default value is 0 this means it’s start directly after creating the patch job, else there needs to give a timestamp in UTC when the job needs to start","readOnly":true},"patchJobStartTime":{"type":"integer","format":"integer","description":"Timestamp when the patch job has been started in UTC","readOnly":true},"finishedAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job has been finished in UTC","readOnly":true},"isRevertable":{"type":"integer","format":"integer","description":"If the patch job can be cancelled","readOnly":true},"patchJobOverallProgress":{"allOf":[{"$ref":"#/components/schemas/PatchJobReportProgress"}],"description":"How many application instances are being patched","nullable":true,"readOnly":true}},"additionalProperties":false},"PatchJobReportProgress":{"type":"object","required":["total","downloaded","stopped","success","failed","started","canceled","remaining"],"properties":{"total":{"type":"integer","format":"integer","description":"The total amount of application instances affected by the patch job","readOnly":true},"downloaded":{"type":"integer","format":"integer","description":"The amount of downloaded application instances","readOnly":true},"stopped":{"type":"integer","format":"integer","description":"The amount of stopped application instances","readOnly":true},"success":{"type":"integer","format":"integer","description":"The amount of successfully patched application instances","readOnly":true},"failed":{"type":"integer","format":"integer","description":"The amount of failed application instances","readOnly":true},"started":{"type":"integer","format":"integer","description":"The amount of started application instances","readOnly":true},"canceled":{"type":"integer","format":"integer","description":"The amount of canceled application instances","readOnly":true},"remaining":{"type":"integer","format":"integer","description":"The amount of remaining application instances","readOnly":true}},"additionalProperties":false,"nullable":true},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/patchJob/summary":{"get":{"tags":["PatchJob"],"summary":"Get summary of all patch jobs","operationId":"getPatchJobSummary","parameters":[{"name":"RANGED-DATA","in":"header","description":"Example header and default range: RANGED-DATA:start=0,results=25","schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobSummary"}}}}},"403":{"description":"Invalid credentials"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/patchJob/deploymentEnvironment/{deploymentEnvironmentId}/application/{applicationId}/fleet

> Gets the list of patch job fleet based on deploymentEnvironmentId and applicationId

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"PatchJob","description":"List all patch job endpoint"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"PatchJobFleetApplicationBuild":{"type":"object","required":["id","name","applicationBuild"],"properties":{"id":{"type":"string","format":"","description":"ID of the fleet","readOnly":true},"name":{"type":"string","format":"","description":"Name of the fleet","readOnly":true},"applicationBuild":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobFleetApplicationBuildDetail"},"description":"Array of the application build belonging to the fleet","readOnly":true}},"additionalProperties":false},"PatchJobFleetApplicationBuildDetail":{"type":"object","required":["id","name","osId"],"properties":{"id":{"type":"string","format":"","description":"ID of the application build","readOnly":true},"name":{"type":"string","format":"","description":"Name of the application build","readOnly":true},"osId":{"type":"integer","format":"integer","description":"ID of the operating system","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/patchJob/deploymentEnvironment/{deploymentEnvironmentId}/application/{applicationId}/fleet":{"get":{"tags":["PatchJob"],"summary":"Gets the list of patch job fleet based on deploymentEnvironmentId and applicationId","operationId":"getPatchJobDeploymentEnvironmentApplicationFleets","parameters":[{"name":"deploymentEnvironmentId","in":"path","description":"The Id of the deployment environment","required":true,"schema":{"type":"string"}},{"name":"applicationId","in":"path","description":"The Id of the application (game or utility)","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobFleetApplicationBuild"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid deploymentEnvironmentId or applicationId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/patchJob/{patchJobId}/email

> Gets the list of reporting emails for a specific patch job

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"PatchJob","description":"List all patch job endpoint"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"PatchJobEmail":{"type":"object","required":["id","email","progressReport","resultReport","createdAt","changedAt"],"properties":{"id":{"type":"string","format":"","description":"ID of a patch job email","readOnly":true},"email":{"type":"string","format":"","description":"Email address for reporting (unique)"},"progressReport":{"type":"integer","format":"integer","description":"If 1 progress report will be send, if 0 no progress report will be send"},"resultReport":{"type":"integer","format":"integer","description":"If 1 result report will be send, if 0 no result report will be send"},"createdAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job email has been created","readOnly":true},"changedAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job email last has been changed","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/patchJob/{patchJobId}/email":{"get":{"tags":["PatchJob"],"summary":"Gets the list of reporting emails for a specific patch job","operationId":"getPatchJobEmails","parameters":[{"name":"patchJobId","in":"path","description":"The Id of the patch job","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobEmail"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid patchJobId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## POST /v3/patchJob/{patchJobId}/email

> Create a patch job report email

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"PatchJob","description":"List all patch job endpoint"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"PatchJobEmail":{"type":"object","required":["id","email","progressReport","resultReport","createdAt","changedAt"],"properties":{"id":{"type":"string","format":"","description":"ID of a patch job email","readOnly":true},"email":{"type":"string","format":"","description":"Email address for reporting (unique)"},"progressReport":{"type":"integer","format":"integer","description":"If 1 progress report will be send, if 0 no progress report will be send"},"resultReport":{"type":"integer","format":"integer","description":"If 1 result report will be send, if 0 no result report will be send"},"createdAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job email has been created","readOnly":true},"changedAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job email last has been changed","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/patchJob/{patchJobId}/email":{"post":{"tags":["PatchJob"],"summary":"Create a patch job report email","operationId":"createPatchJobEmail","parameters":[{"name":"patchJobId","in":"path","description":"The Id of the patch job","required":true,"schema":{"type":"string"}}],"requestBody":{"description":"","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PatchJobEmail"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobEmail"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid patchJobId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## PUT /v3/patchJob/{patchJobId}/hold

> Put a given patch job on hold

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"PatchJob","description":"List all patch job endpoint"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"PatchJob":{"type":"object","required":["id","deploymentEnvironmentId","applicationId","patchJobMethodId","patchJobMethod","patchJobName","status","stopMethodId","stopMethodName","patchJobStartTime","patchJobOverallProgress","applicationBuild","fleet","createdAt","changedAt","finishedAt","isRevertable","revertsPatchJobId","revertedByPatchJobId"],"properties":{"id":{"type":"string","format":"","description":"Patch job ID","readOnly":true},"deploymentEnvironmentId":{"type":"string","format":"","description":"Deployment environment ID"},"applicationId":{"type":"string","format":"","description":"Application ID"},"patchJobMethodId":{"type":"integer","format":"integer","description":"Patch job type, you can find the list available patch job type [`GET /v3/patchJob/type`](game-publisher#/PatchJob/get_v3_patchJob_type)"},"patchJobMethod":{"type":"string","format":"","description":"Name of the patch job method","readOnly":true},"patchJobName":{"type":"string","format":"","description":"Name of the patch job (unique)"},"status":{"type":"integer","format":"integer","description":"Status of the patch job, you can find the list available patch job type [`GET /v3/patchJob/status`](game-publisher#/PatchJob/get_v3_patchJob_status)","readOnly":true},"stopMethodId":{"type":"integer","format":"integer","description":"Stop method of an application instance, you can find the list available application instance stop methods [`GET /v3/application/stopMethod`](game-publisher#/Application/get_v3_application_stopMethod)"},"stopMethodName":{"type":"string","format":"","description":"Name of the stop method","readOnly":true},"stopMethodTimeout":{"type":"integer","format":"integer","description":"Stop method timeout of an application instance in seconds"},"comments":{"type":"string","format":"","description":"Comments for patch job"},"schedulerStartTime":{"type":"integer","format":"integer","description":"Start time when the patch job will be started. The default value is 0, this means start directly after creation of the patch job, else the patch job will start at the provided UTC timestamp"},"patchJobStartTime":{"type":"integer","format":"integer","description":"Timestamp when the patch job has been started in UTC","readOnly":true},"patchJobOverallProgress":{"allOf":[{"$ref":"#/components/schemas/PatchJobReportProgress"}],"description":"How many application instances are being patched","nullable":true,"readOnly":true},"applicationBuild":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobApplicationBuild"},"description":"Array of old and new application build needs to be patched"},"fleet":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobFleet"},"description":"Array of fleet that needs to be patched"},"email":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobEmail"},"description":"Array of email address for reporting purposes"},"createdAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job has been created","readOnly":true},"changedAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job last has been changed","readOnly":true},"finishedAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job has been finished in UTC","readOnly":true},"isRevertable":{"type":"integer","format":"integer","description":"If the patch job can be cancelled, when is 1 you can cancel the patch job else not","readOnly":true},"revertsPatchJobId":{"type":"integer","format":"integer","description":"If filled in, this ID points to the patch job that has been reverted by this patch job","nullable":true,"readOnly":true},"revertedByPatchJobId":{"type":"integer","format":"integer","description":"If filled in, this ID points to the PatchJob that has reverted this patch job","nullable":true,"readOnly":true}},"additionalProperties":false},"PatchJobReportProgress":{"type":"object","required":["total","downloaded","stopped","success","failed","started","canceled","remaining"],"properties":{"total":{"type":"integer","format":"integer","description":"The total amount of application instances affected by the patch job","readOnly":true},"downloaded":{"type":"integer","format":"integer","description":"The amount of downloaded application instances","readOnly":true},"stopped":{"type":"integer","format":"integer","description":"The amount of stopped application instances","readOnly":true},"success":{"type":"integer","format":"integer","description":"The amount of successfully patched application instances","readOnly":true},"failed":{"type":"integer","format":"integer","description":"The amount of failed application instances","readOnly":true},"started":{"type":"integer","format":"integer","description":"The amount of started application instances","readOnly":true},"canceled":{"type":"integer","format":"integer","description":"The amount of canceled application instances","readOnly":true},"remaining":{"type":"integer","format":"integer","description":"The amount of remaining application instances","readOnly":true}},"additionalProperties":false,"nullable":true},"PatchJobApplicationBuild":{"type":"object","required":["id","oldApplicationBuildId","newApplicationBuildId"],"properties":{"id":{"type":"string","format":"","description":"ID of a patch job application build","readOnly":true},"oldApplicationBuildId":{"type":"string","format":"","description":"ID of an old application build"},"newApplicationBuildId":{"type":"string","format":"","description":"ID of a new application build"}},"additionalProperties":false},"PatchJobFleet":{"type":"object","required":["id","fleetId"],"properties":{"id":{"type":"string","format":"","description":"ID of a patch job fleet","readOnly":true},"fleetId":{"type":"string","format":"","description":"ID of fleet"}},"additionalProperties":false},"PatchJobEmail":{"type":"object","required":["id","email","progressReport","resultReport","createdAt","changedAt"],"properties":{"id":{"type":"string","format":"","description":"ID of a patch job email","readOnly":true},"email":{"type":"string","format":"","description":"Email address for reporting (unique)"},"progressReport":{"type":"integer","format":"integer","description":"If 1 progress report will be send, if 0 no progress report will be send"},"resultReport":{"type":"integer","format":"integer","description":"If 1 result report will be send, if 0 no result report will be send"},"createdAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job email has been created","readOnly":true},"changedAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job email last has been changed","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/patchJob/{patchJobId}/hold":{"put":{"tags":["PatchJob"],"summary":"Put a given patch job on hold","operationId":"updatePatchJobHold","parameters":[{"name":"patchJobId","in":"path","description":"The Id of the patch job to put on hold","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/PatchJob"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid patchJobId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## PUT /v3/patchJob/{patchJobId}/unhold

> Unhold the given patch job

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"PatchJob","description":"List all patch job endpoint"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"PatchJob":{"type":"object","required":["id","deploymentEnvironmentId","applicationId","patchJobMethodId","patchJobMethod","patchJobName","status","stopMethodId","stopMethodName","patchJobStartTime","patchJobOverallProgress","applicationBuild","fleet","createdAt","changedAt","finishedAt","isRevertable","revertsPatchJobId","revertedByPatchJobId"],"properties":{"id":{"type":"string","format":"","description":"Patch job ID","readOnly":true},"deploymentEnvironmentId":{"type":"string","format":"","description":"Deployment environment ID"},"applicationId":{"type":"string","format":"","description":"Application ID"},"patchJobMethodId":{"type":"integer","format":"integer","description":"Patch job type, you can find the list available patch job type [`GET /v3/patchJob/type`](game-publisher#/PatchJob/get_v3_patchJob_type)"},"patchJobMethod":{"type":"string","format":"","description":"Name of the patch job method","readOnly":true},"patchJobName":{"type":"string","format":"","description":"Name of the patch job (unique)"},"status":{"type":"integer","format":"integer","description":"Status of the patch job, you can find the list available patch job type [`GET /v3/patchJob/status`](game-publisher#/PatchJob/get_v3_patchJob_status)","readOnly":true},"stopMethodId":{"type":"integer","format":"integer","description":"Stop method of an application instance, you can find the list available application instance stop methods [`GET /v3/application/stopMethod`](game-publisher#/Application/get_v3_application_stopMethod)"},"stopMethodName":{"type":"string","format":"","description":"Name of the stop method","readOnly":true},"stopMethodTimeout":{"type":"integer","format":"integer","description":"Stop method timeout of an application instance in seconds"},"comments":{"type":"string","format":"","description":"Comments for patch job"},"schedulerStartTime":{"type":"integer","format":"integer","description":"Start time when the patch job will be started. The default value is 0, this means start directly after creation of the patch job, else the patch job will start at the provided UTC timestamp"},"patchJobStartTime":{"type":"integer","format":"integer","description":"Timestamp when the patch job has been started in UTC","readOnly":true},"patchJobOverallProgress":{"allOf":[{"$ref":"#/components/schemas/PatchJobReportProgress"}],"description":"How many application instances are being patched","nullable":true,"readOnly":true},"applicationBuild":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobApplicationBuild"},"description":"Array of old and new application build needs to be patched"},"fleet":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobFleet"},"description":"Array of fleet that needs to be patched"},"email":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobEmail"},"description":"Array of email address for reporting purposes"},"createdAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job has been created","readOnly":true},"changedAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job last has been changed","readOnly":true},"finishedAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job has been finished in UTC","readOnly":true},"isRevertable":{"type":"integer","format":"integer","description":"If the patch job can be cancelled, when is 1 you can cancel the patch job else not","readOnly":true},"revertsPatchJobId":{"type":"integer","format":"integer","description":"If filled in, this ID points to the patch job that has been reverted by this patch job","nullable":true,"readOnly":true},"revertedByPatchJobId":{"type":"integer","format":"integer","description":"If filled in, this ID points to the PatchJob that has reverted this patch job","nullable":true,"readOnly":true}},"additionalProperties":false},"PatchJobReportProgress":{"type":"object","required":["total","downloaded","stopped","success","failed","started","canceled","remaining"],"properties":{"total":{"type":"integer","format":"integer","description":"The total amount of application instances affected by the patch job","readOnly":true},"downloaded":{"type":"integer","format":"integer","description":"The amount of downloaded application instances","readOnly":true},"stopped":{"type":"integer","format":"integer","description":"The amount of stopped application instances","readOnly":true},"success":{"type":"integer","format":"integer","description":"The amount of successfully patched application instances","readOnly":true},"failed":{"type":"integer","format":"integer","description":"The amount of failed application instances","readOnly":true},"started":{"type":"integer","format":"integer","description":"The amount of started application instances","readOnly":true},"canceled":{"type":"integer","format":"integer","description":"The amount of canceled application instances","readOnly":true},"remaining":{"type":"integer","format":"integer","description":"The amount of remaining application instances","readOnly":true}},"additionalProperties":false,"nullable":true},"PatchJobApplicationBuild":{"type":"object","required":["id","oldApplicationBuildId","newApplicationBuildId"],"properties":{"id":{"type":"string","format":"","description":"ID of a patch job application build","readOnly":true},"oldApplicationBuildId":{"type":"string","format":"","description":"ID of an old application build"},"newApplicationBuildId":{"type":"string","format":"","description":"ID of a new application build"}},"additionalProperties":false},"PatchJobFleet":{"type":"object","required":["id","fleetId"],"properties":{"id":{"type":"string","format":"","description":"ID of a patch job fleet","readOnly":true},"fleetId":{"type":"string","format":"","description":"ID of fleet"}},"additionalProperties":false},"PatchJobEmail":{"type":"object","required":["id","email","progressReport","resultReport","createdAt","changedAt"],"properties":{"id":{"type":"string","format":"","description":"ID of a patch job email","readOnly":true},"email":{"type":"string","format":"","description":"Email address for reporting (unique)"},"progressReport":{"type":"integer","format":"integer","description":"If 1 progress report will be send, if 0 no progress report will be send"},"resultReport":{"type":"integer","format":"integer","description":"If 1 result report will be send, if 0 no result report will be send"},"createdAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job email has been created","readOnly":true},"changedAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job email last has been changed","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/patchJob/{patchJobId}/unhold":{"put":{"tags":["PatchJob"],"summary":"Unhold the given patch job","operationId":"updatePatchJobUnhold","parameters":[{"name":"patchJobId","in":"path","description":"The Id of the patch job","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/PatchJob"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid patchJobId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## PUT /v3/patchJob/{patchJobId}/cancel

> Cancel the given patch job

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"PatchJob","description":"List all patch job endpoint"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"PatchJob":{"type":"object","required":["id","deploymentEnvironmentId","applicationId","patchJobMethodId","patchJobMethod","patchJobName","status","stopMethodId","stopMethodName","patchJobStartTime","patchJobOverallProgress","applicationBuild","fleet","createdAt","changedAt","finishedAt","isRevertable","revertsPatchJobId","revertedByPatchJobId"],"properties":{"id":{"type":"string","format":"","description":"Patch job ID","readOnly":true},"deploymentEnvironmentId":{"type":"string","format":"","description":"Deployment environment ID"},"applicationId":{"type":"string","format":"","description":"Application ID"},"patchJobMethodId":{"type":"integer","format":"integer","description":"Patch job type, you can find the list available patch job type [`GET /v3/patchJob/type`](game-publisher#/PatchJob/get_v3_patchJob_type)"},"patchJobMethod":{"type":"string","format":"","description":"Name of the patch job method","readOnly":true},"patchJobName":{"type":"string","format":"","description":"Name of the patch job (unique)"},"status":{"type":"integer","format":"integer","description":"Status of the patch job, you can find the list available patch job type [`GET /v3/patchJob/status`](game-publisher#/PatchJob/get_v3_patchJob_status)","readOnly":true},"stopMethodId":{"type":"integer","format":"integer","description":"Stop method of an application instance, you can find the list available application instance stop methods [`GET /v3/application/stopMethod`](game-publisher#/Application/get_v3_application_stopMethod)"},"stopMethodName":{"type":"string","format":"","description":"Name of the stop method","readOnly":true},"stopMethodTimeout":{"type":"integer","format":"integer","description":"Stop method timeout of an application instance in seconds"},"comments":{"type":"string","format":"","description":"Comments for patch job"},"schedulerStartTime":{"type":"integer","format":"integer","description":"Start time when the patch job will be started. The default value is 0, this means start directly after creation of the patch job, else the patch job will start at the provided UTC timestamp"},"patchJobStartTime":{"type":"integer","format":"integer","description":"Timestamp when the patch job has been started in UTC","readOnly":true},"patchJobOverallProgress":{"allOf":[{"$ref":"#/components/schemas/PatchJobReportProgress"}],"description":"How many application instances are being patched","nullable":true,"readOnly":true},"applicationBuild":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobApplicationBuild"},"description":"Array of old and new application build needs to be patched"},"fleet":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobFleet"},"description":"Array of fleet that needs to be patched"},"email":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobEmail"},"description":"Array of email address for reporting purposes"},"createdAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job has been created","readOnly":true},"changedAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job last has been changed","readOnly":true},"finishedAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job has been finished in UTC","readOnly":true},"isRevertable":{"type":"integer","format":"integer","description":"If the patch job can be cancelled, when is 1 you can cancel the patch job else not","readOnly":true},"revertsPatchJobId":{"type":"integer","format":"integer","description":"If filled in, this ID points to the patch job that has been reverted by this patch job","nullable":true,"readOnly":true},"revertedByPatchJobId":{"type":"integer","format":"integer","description":"If filled in, this ID points to the PatchJob that has reverted this patch job","nullable":true,"readOnly":true}},"additionalProperties":false},"PatchJobReportProgress":{"type":"object","required":["total","downloaded","stopped","success","failed","started","canceled","remaining"],"properties":{"total":{"type":"integer","format":"integer","description":"The total amount of application instances affected by the patch job","readOnly":true},"downloaded":{"type":"integer","format":"integer","description":"The amount of downloaded application instances","readOnly":true},"stopped":{"type":"integer","format":"integer","description":"The amount of stopped application instances","readOnly":true},"success":{"type":"integer","format":"integer","description":"The amount of successfully patched application instances","readOnly":true},"failed":{"type":"integer","format":"integer","description":"The amount of failed application instances","readOnly":true},"started":{"type":"integer","format":"integer","description":"The amount of started application instances","readOnly":true},"canceled":{"type":"integer","format":"integer","description":"The amount of canceled application instances","readOnly":true},"remaining":{"type":"integer","format":"integer","description":"The amount of remaining application instances","readOnly":true}},"additionalProperties":false,"nullable":true},"PatchJobApplicationBuild":{"type":"object","required":["id","oldApplicationBuildId","newApplicationBuildId"],"properties":{"id":{"type":"string","format":"","description":"ID of a patch job application build","readOnly":true},"oldApplicationBuildId":{"type":"string","format":"","description":"ID of an old application build"},"newApplicationBuildId":{"type":"string","format":"","description":"ID of a new application build"}},"additionalProperties":false},"PatchJobFleet":{"type":"object","required":["id","fleetId"],"properties":{"id":{"type":"string","format":"","description":"ID of a patch job fleet","readOnly":true},"fleetId":{"type":"string","format":"","description":"ID of fleet"}},"additionalProperties":false},"PatchJobEmail":{"type":"object","required":["id","email","progressReport","resultReport","createdAt","changedAt"],"properties":{"id":{"type":"string","format":"","description":"ID of a patch job email","readOnly":true},"email":{"type":"string","format":"","description":"Email address for reporting (unique)"},"progressReport":{"type":"integer","format":"integer","description":"If 1 progress report will be send, if 0 no progress report will be send"},"resultReport":{"type":"integer","format":"integer","description":"If 1 result report will be send, if 0 no result report will be send"},"createdAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job email has been created","readOnly":true},"changedAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job email last has been changed","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/patchJob/{patchJobId}/cancel":{"put":{"tags":["PatchJob"],"summary":"Cancel the given patch job","operationId":"updatePatchJobCancel","parameters":[{"name":"patchJobId","in":"path","description":"The Id of the patch job","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/PatchJob"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid patchJobId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## PUT /v3/patchJob/{patchJobId}/stop

> Stops the given patch job and set the patch job to success

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"PatchJob","description":"List all patch job endpoint"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/patchJob/{patchJobId}/stop":{"put":{"tags":["PatchJob"],"summary":"Stops the given patch job and set the patch job to success","operationId":"updatePatchJobStop","parameters":[{"name":"patchJobId","in":"path","description":"The Id of the patch job","required":true,"schema":{"type":"string"}}],"responses":{"204":{"description":"No Content"},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid patchJobId"},"422":{"description":"unprocessable patchJob"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## DELETE /v3/patchJob/{patchJobId}/email/{patchJobReportEmailId}

> Delete a patch job report email

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"PatchJob","description":"List all patch job endpoint"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"PatchJob":{"type":"object","required":["id","deploymentEnvironmentId","applicationId","patchJobMethodId","patchJobMethod","patchJobName","status","stopMethodId","stopMethodName","patchJobStartTime","patchJobOverallProgress","applicationBuild","fleet","createdAt","changedAt","finishedAt","isRevertable","revertsPatchJobId","revertedByPatchJobId"],"properties":{"id":{"type":"string","format":"","description":"Patch job ID","readOnly":true},"deploymentEnvironmentId":{"type":"string","format":"","description":"Deployment environment ID"},"applicationId":{"type":"string","format":"","description":"Application ID"},"patchJobMethodId":{"type":"integer","format":"integer","description":"Patch job type, you can find the list available patch job type [`GET /v3/patchJob/type`](game-publisher#/PatchJob/get_v3_patchJob_type)"},"patchJobMethod":{"type":"string","format":"","description":"Name of the patch job method","readOnly":true},"patchJobName":{"type":"string","format":"","description":"Name of the patch job (unique)"},"status":{"type":"integer","format":"integer","description":"Status of the patch job, you can find the list available patch job type [`GET /v3/patchJob/status`](game-publisher#/PatchJob/get_v3_patchJob_status)","readOnly":true},"stopMethodId":{"type":"integer","format":"integer","description":"Stop method of an application instance, you can find the list available application instance stop methods [`GET /v3/application/stopMethod`](game-publisher#/Application/get_v3_application_stopMethod)"},"stopMethodName":{"type":"string","format":"","description":"Name of the stop method","readOnly":true},"stopMethodTimeout":{"type":"integer","format":"integer","description":"Stop method timeout of an application instance in seconds"},"comments":{"type":"string","format":"","description":"Comments for patch job"},"schedulerStartTime":{"type":"integer","format":"integer","description":"Start time when the patch job will be started. The default value is 0, this means start directly after creation of the patch job, else the patch job will start at the provided UTC timestamp"},"patchJobStartTime":{"type":"integer","format":"integer","description":"Timestamp when the patch job has been started in UTC","readOnly":true},"patchJobOverallProgress":{"allOf":[{"$ref":"#/components/schemas/PatchJobReportProgress"}],"description":"How many application instances are being patched","nullable":true,"readOnly":true},"applicationBuild":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobApplicationBuild"},"description":"Array of old and new application build needs to be patched"},"fleet":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobFleet"},"description":"Array of fleet that needs to be patched"},"email":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobEmail"},"description":"Array of email address for reporting purposes"},"createdAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job has been created","readOnly":true},"changedAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job last has been changed","readOnly":true},"finishedAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job has been finished in UTC","readOnly":true},"isRevertable":{"type":"integer","format":"integer","description":"If the patch job can be cancelled, when is 1 you can cancel the patch job else not","readOnly":true},"revertsPatchJobId":{"type":"integer","format":"integer","description":"If filled in, this ID points to the patch job that has been reverted by this patch job","nullable":true,"readOnly":true},"revertedByPatchJobId":{"type":"integer","format":"integer","description":"If filled in, this ID points to the PatchJob that has reverted this patch job","nullable":true,"readOnly":true}},"additionalProperties":false},"PatchJobReportProgress":{"type":"object","required":["total","downloaded","stopped","success","failed","started","canceled","remaining"],"properties":{"total":{"type":"integer","format":"integer","description":"The total amount of application instances affected by the patch job","readOnly":true},"downloaded":{"type":"integer","format":"integer","description":"The amount of downloaded application instances","readOnly":true},"stopped":{"type":"integer","format":"integer","description":"The amount of stopped application instances","readOnly":true},"success":{"type":"integer","format":"integer","description":"The amount of successfully patched application instances","readOnly":true},"failed":{"type":"integer","format":"integer","description":"The amount of failed application instances","readOnly":true},"started":{"type":"integer","format":"integer","description":"The amount of started application instances","readOnly":true},"canceled":{"type":"integer","format":"integer","description":"The amount of canceled application instances","readOnly":true},"remaining":{"type":"integer","format":"integer","description":"The amount of remaining application instances","readOnly":true}},"additionalProperties":false,"nullable":true},"PatchJobApplicationBuild":{"type":"object","required":["id","oldApplicationBuildId","newApplicationBuildId"],"properties":{"id":{"type":"string","format":"","description":"ID of a patch job application build","readOnly":true},"oldApplicationBuildId":{"type":"string","format":"","description":"ID of an old application build"},"newApplicationBuildId":{"type":"string","format":"","description":"ID of a new application build"}},"additionalProperties":false},"PatchJobFleet":{"type":"object","required":["id","fleetId"],"properties":{"id":{"type":"string","format":"","description":"ID of a patch job fleet","readOnly":true},"fleetId":{"type":"string","format":"","description":"ID of fleet"}},"additionalProperties":false},"PatchJobEmail":{"type":"object","required":["id","email","progressReport","resultReport","createdAt","changedAt"],"properties":{"id":{"type":"string","format":"","description":"ID of a patch job email","readOnly":true},"email":{"type":"string","format":"","description":"Email address for reporting (unique)"},"progressReport":{"type":"integer","format":"integer","description":"If 1 progress report will be send, if 0 no progress report will be send"},"resultReport":{"type":"integer","format":"integer","description":"If 1 result report will be send, if 0 no result report will be send"},"createdAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job email has been created","readOnly":true},"changedAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job email last has been changed","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/patchJob/{patchJobId}/email/{patchJobReportEmailId}":{"delete":{"tags":["PatchJob"],"summary":"Delete a patch job report email","operationId":"deletePatchJobEmail","parameters":[{"name":"patchJobId","in":"path","description":"The Id of the patch job","required":true,"schema":{"type":"string"}},{"name":"patchJobReportEmailId","in":"path","description":"The Id of the patch job report email","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/PatchJob"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid patchJobId or reportEmailId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## PUT /v3/patchJob/{patchJobId}/email/bulk

> Create, update and remove patch job report email

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"PatchJob","description":"List all patch job endpoint"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"PatchJobEmailBulk":{"type":"object","required":["patchJobEmail"],"properties":{"patchJobEmail":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobEmail"},"description":"Array of patch job email address for reporting purposes"}},"additionalProperties":false},"PatchJobEmail":{"type":"object","required":["id","email","progressReport","resultReport","createdAt","changedAt"],"properties":{"id":{"type":"string","format":"","description":"ID of a patch job email","readOnly":true},"email":{"type":"string","format":"","description":"Email address for reporting (unique)"},"progressReport":{"type":"integer","format":"integer","description":"If 1 progress report will be send, if 0 no progress report will be send"},"resultReport":{"type":"integer","format":"integer","description":"If 1 result report will be send, if 0 no result report will be send"},"createdAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job email has been created","readOnly":true},"changedAt":{"type":"integer","format":"integer","description":"Timestamp when the patch job email last has been changed","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/patchJob/{patchJobId}/email/bulk":{"put":{"tags":["PatchJob"],"summary":"Create, update and remove patch job report email","operationId":"updatePatchJobEmailBulk","parameters":[{"name":"patchJobId","in":"path","description":"The Id of the patch job","required":true,"schema":{"type":"string"}}],"requestBody":{"description":"","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PatchJobEmailBulk"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobEmail"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid patchJobId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/patchJob/{patchJobId}/report/progress

> Get gives back the progress of the patch job

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"PatchJob","description":"List all patch job endpoint"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"PatchJobReport":{"type":"object","required":["patchJobId","patchJobName","changedAt","finishedAt","startedAt","patchJobMethodName","patchJobStatus","deploymentEnvironment","oldApplicationBuilds","newApplicationBuild","progress","fleetData"],"properties":{"patchJobId":{"type":"string","format":"","description":"Patch job ID","readOnly":true},"patchJobName":{"type":"string","format":"","description":"Name of the patch job","readOnly":true},"changedAt":{"type":"integer","format":"integer","description":"Unix timestamp when the status of the patch job has been changed","readOnly":true},"finishedAt":{"type":"integer","format":"integer","description":"Unix timestamp when the patch job finished (if `0` then the patch job is still running)","readOnly":true},"startedAt":{"type":"integer","format":"integer","description":"Unix timestamp when the patch job started","readOnly":true},"patchJobMethodName":{"type":"string","format":"","description":"Name of the patch job method (strategy)","readOnly":true},"patchJobStatus":{"type":"integer","format":"integer","description":"Status of the patch job","readOnly":true},"deploymentEnvironment":{"allOf":[{"$ref":"#/components/schemas/GenericModel"}],"description":"The deployment environment","readOnly":true},"oldApplicationBuilds":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobReportApplicationBuild"},"description":"List of old application builds","readOnly":true},"newApplicationBuild":{"allOf":[{"$ref":"#/components/schemas/PatchJobReportApplicationBuild"}],"description":"The new application build","readOnly":true},"progress":{"allOf":[{"$ref":"#/components/schemas/PatchJobReportProgress"}],"description":"Progress across all fleets - total for the entire patch job","readOnly":true},"fleetData":{"type":"array","items":{"$ref":"#/components/schemas/PatchJobReportFleet"},"description":"Patch job report data based on fleet","readOnly":true}},"additionalProperties":false},"GenericModel":{"type":"object","required":["id","name"],"properties":{"id":{"type":"string","format":"","description":"The ID of the object"},"name":{"type":"string","format":"","description":"The name of the object"}},"additionalProperties":false},"PatchJobReportApplicationBuild":{"type":"object","required":["id","name","version"],"properties":{"id":{"type":"string","format":"","description":"Application build ID","readOnly":true},"name":{"type":"string","format":"","description":"The name of the application build"},"version":{"type":"string","format":"","description":"The version of the application install or build provisioning file linked to this application build"}},"additionalProperties":false},"PatchJobReportProgress":{"type":"object","required":["total","downloaded","stopped","success","failed","started","canceled","remaining"],"properties":{"total":{"type":"integer","format":"integer","description":"The total amount of application instances affected by the patch job","readOnly":true},"downloaded":{"type":"integer","format":"integer","description":"The amount of downloaded application instances","readOnly":true},"stopped":{"type":"integer","format":"integer","description":"The amount of stopped application instances","readOnly":true},"success":{"type":"integer","format":"integer","description":"The amount of successfully patched application instances","readOnly":true},"failed":{"type":"integer","format":"integer","description":"The amount of failed application instances","readOnly":true},"started":{"type":"integer","format":"integer","description":"The amount of started application instances","readOnly":true},"canceled":{"type":"integer","format":"integer","description":"The amount of canceled application instances","readOnly":true},"remaining":{"type":"integer","format":"integer","description":"The amount of remaining application instances","readOnly":true}},"additionalProperties":false,"nullable":true},"PatchJobReportFleet":{"type":"object","required":["fleet","progress","deploymentRegionData"],"properties":{"fleet":{"allOf":[{"$ref":"#/components/schemas/GenericModel"}],"description":"The Fleet details","readOnly":true},"progress":{"a
[...]
